// Copyright (c) 2016, 2018, 2024, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// OCI Control Center Capacity Management API
//
// OCI Control Center (OCC) Capacity Management enables you to manage capacity requests in realms where OCI Control Center Capacity Management is available. For more information, see OCI Control Center (https://docs.cloud.oracle.com/iaas/Content/control-center/home.htm).
//

package capacitymanagement

import (
	"fmt"
	"github.com/oracle/oci-go-sdk/v65/common"
	"strings"
)

// OccHandoverResourceBlockDetailSummary Detailed information about a particular occHandoverResourceBlock.
// For compute namespace this information includes host serial, host ocid etc.
type OccHandoverResourceBlockDetailSummary struct {

	// The OCID of the occResourceHandoverBlock.
	OccResourceHandoverBlockId *string `mandatory:"true" json:"occResourceHandoverBlockId"`

	// A map that contains additional details for a given handover resource. For example for compute namespace this includes host ocid, host serial etc.
	Details map[string]string `mandatory:"true" json:"details"`
}

func (m OccHandoverResourceBlockDetailSummary) String() string {
	return common.PointerString(m)
}

// ValidateEnumValue returns an error when providing an unsupported enum value
// This function is being called during constructing API request process
// Not recommended for calling this function directly
func (m OccHandoverResourceBlockDetailSummary) ValidateEnumValue() (bool, error) {
	errMessage := []string{}

	if len(errMessage) > 0 {
		return true, fmt.Errorf(strings.Join(errMessage, "\n"))
	}
	return false, nil
}
